"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startServer = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _express = _interopRequireDefault(require("express"));

var _cookieParser = _interopRequireDefault(require("cookie-parser"));

var _cors = _interopRequireDefault(require("cors"));

var _morgan = _interopRequireDefault(require("morgan"));

var _passport = _interopRequireDefault(require("passport"));

var _utils = require("./helpers/utils");

var _notFound = _interopRequireDefault(require("./middlewares/not-found"));

var _routes = require("./routes");

var _db = require("./db");

var PORT = process.env.PORT || 4200;
var app = (0, _express["default"])();
app.use(_express["default"].json());
app.use(_express["default"].urlencoded({
  extended: false
}));
app.use((0, _cookieParser["default"])());
app.use((0, _morgan["default"])('dev'));
app.use((0, _cors["default"])({
  origin: ['https://dashboard.pokt.network', 'https://mainnet.dashboard.pokt.network', 'https://testnet.dashboard.pokt.network', 'http://localhost:3000'],
  methods: ['POST', 'PUT', 'GET', 'OPTIONS', 'HEAD'],
  credentials: true,
  exposedHeaders: ['Authorization']
}));

_passport["default"].initialize();

(0, _routes.configureRoutes)(app);
app.use((0, _notFound["default"])());
app.use((0, _utils.errorHandler)());

var startServer = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return (0, _db.connect)();

          case 3:
            app.listen(PORT, function () {
              console.log("App listening to ".concat(PORT, "...."));
              console.log('Press Ctrl+C to quit.');
            });
            _context.next = 9;
            break;

          case 6:
            _context.prev = 6;
            _context.t0 = _context["catch"](0);
            console.error(_context.t0); // TODO: Log error to sentry

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 6]]);
  }));

  return function startServer() {
    return _ref.apply(this, arguments);
  };
}();

exports.startServer = startServer;
//# sourceMappingURL=App.js.map