"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = env;
exports.ENV_VARS = void 0;

var dotenv = _interopRequireWildcard(require("dotenv"));

dotenv.config();
var ENV_VARS = {
  prod: function prod() {
    return process.env.NODE_ENV === 'production';
  },
  FRONTEND_URL: function FRONTEND_URL() {
    return process.env.FRONTEND_URL || 'http://localhost:3000';
  },
  ALLOWED_DOMAINS: function ALLOWED_DOMAINS() {
    var _process$env$ALLOWED_, _process$env$ALLOWED_2;

    return (_process$env$ALLOWED_ = (_process$env$ALLOWED_2 = process.env.ALLOWED_DOMAINS) === null || _process$env$ALLOWED_2 === void 0 ? void 0 : _process$env$ALLOWED_2.split(',')) !== null && _process$env$ALLOWED_ !== void 0 ? _process$env$ALLOWED_ : ['http://localhost:3000'];
  },
  ENABLE_WORKERS: function ENABLE_WORKERS() {
    return process.env.ENABLE_WORKERS === 'true' || false;
  },
  HASURA_SECRET: function HASURA_SECRET() {
    return process.env.HASURA_ADMIN_SECRET || '';
  },
  HASURA_URL: function HASURA_URL() {
    var _process$env$HASURA_U, _process$env$HASURA_U2;

    return (_process$env$HASURA_U = (_process$env$HASURA_U2 = process.env.HASURA_URL) === null || _process$env$HASURA_U2 === void 0 ? void 0 : _process$env$HASURA_U2.trim()) !== null && _process$env$HASURA_U !== void 0 ? _process$env$HASURA_U : '';
  },
  AUTH: function AUTH() {
    var _process$env$JWT_PUBL, _process$env$JWT_PUBL2, _process$env$JWT_PRIV, _process$env$JWT_PRIV2;

    return {
      publicSecret: (_process$env$JWT_PUBL = (_process$env$JWT_PUBL2 = process.env.JWT_PUBLIC_SECRET) === null || _process$env$JWT_PUBL2 === void 0 ? void 0 : _process$env$JWT_PUBL2.replace(/\\n/gm, '\n')) !== null && _process$env$JWT_PUBL !== void 0 ? _process$env$JWT_PUBL : '',
      privateSecret: (_process$env$JWT_PRIV = (_process$env$JWT_PRIV2 = process.env.JWT_PRIVATE_SECRET) === null || _process$env$JWT_PRIV2 === void 0 ? void 0 : _process$env$JWT_PRIV2.replace(/\\n/gm, '\n')) !== null && _process$env$JWT_PRIV !== void 0 ? _process$env$JWT_PRIV : '',
      secretKey: process.env.JWT_SECRET_KEY,
      expiration: process.env.JWT_EXPIRATION,
      refreshExpiration: process.env.JWT_REFRESH_EXPIRATION
    };
  },
  EMAIL_API_KEY: function EMAIL_API_KEY() {
    var _process$env$EMAIL_AP, _process$env$EMAIL_AP2;

    return (_process$env$EMAIL_AP = (_process$env$EMAIL_AP2 = process.env.EMAIL_API_KEY) === null || _process$env$EMAIL_AP2 === void 0 ? void 0 : _process$env$EMAIL_AP2.trim()) !== null && _process$env$EMAIL_AP !== void 0 ? _process$env$EMAIL_AP : '';
  },
  EMAIL_FROM: function EMAIL_FROM() {
    return process.env.EMAIL_FROM;
  },
  // TODO: Refactor to have better names
  PERSISTENCE: function PERSISTENCE() {
    return {
      url: process.env.DATABASE_URL,
      dbUser: process.env.DATABASE_USER,
      dbPassword: process.env.DATABASE_PASSWORD,
      dbName: process.env.DATABASE_NAME,
      dbEncryptionKey: process.env.DATABASE_ENCRYPTION_KEY
    };
  },
  POCKET_NETWORK: function POCKET_NETWORK() {
    return {
      aatVersion: process.env.POCKET_NETWORK_AAT_VERSION,
      blockTime: process.env.POCKET_NETWORK_BLOCK_TIME,
      transactionFee: process.env.POCKET_NETWORK_TRANSACTION_FEE,
      chainId: process.env.POCKET_NETWORK_CHAIN_ID,
      maxDispatchers: process.env.POCKET_NETWORK_MAX_DISPATCHER,
      requestTimeout: process.env.POCKET_NETWORK_REQUEST_TIMEOUT,
      maxSessions: process.env.POCKET_NETWORK_MAX_SESSIONS,
      freeTierFundAccount: process.env.POCKET_NETWORK_FREE_TIER_FUND_ACCOUNT,
      freeTierFundAddress: process.env.POCKET_NETWORK_FREE_TIER_FUND_ADDRESS,
      freeTierClientPubKey: process.env.POCKET_NETWORK_CLIENT_PUB_KEY,
      dispatchers: process.env.POCKET_NETWORK_DISPATCHERS,
      chainHash: process.env.POCKET_NETWORK_CHAIN_HASH,
      providerType: process.env.POCKET_NETWORK_PROVIDER_TYPE,
      httpProviderNode: process.env.POCKET_NETWORK_HTTP_PROVIDER_NODE,
      mainFundAccount: process.env.POCKET_NETWORK_MAIN_FUND_ACCOUNT,
      mainFundAddress: process.env.POCKET_NETWORK_MAIN_FUND_ADDRESS,
      clientPubKey: process.env.POCKET_NETWORK_CLIENT_PUB_KEY // aat_version: process.env.POCKET_NETWORK_AAT_VERSION,
      // transaction_fee: process.env.POCKET_NETWORK_TRANSACTION_FEE,
      // chain_id: process.env.POCKET_NETWORK_CHAIN_ID,
      // max_dispatchers: process.env.POCKET_NETWORK_MAX_DISPATCHER,
      // request_timeout: process.env.POCKET_NETWORK_REQUEST_TIMEOUT,
      // max_sessions: process.env.POCKET_NETWORK_MAX_SESSIONS,
      // free_tier: {
      // stake_amount: process.env.POCKET_FREE_TIER_STAKE_AMOUNT,
      // max_relay_per_day_amount:
      // process.env.POCKET_FREE_TIER_MAX_RELAY_PER_DAY_AMOUNT,
      // fund_account: process.env.POCKET_NETWORK_FREE_TIER_FUND_ACCOUNT,
      // fund_address: process.env.POCKET_NETWORK_FREE_TIER_FUND_ADDRESS,
      // client_pub_key: process.env.POCKET_NETWORK_CLIENT_PUB_KEY,
      // },
      // dispatchers: process.env.POCKET_NETWORK_DISPATCHERS,
      // chain_hash: process.env.POCKET_NETWORK_CHAIN_HASH,
      // provider_type: process.env.POCKET_NETWORK_PROVIDER_TYPE,
      // http_provider_node: process.env.POCKET_NETWORK_HTTP_PROVIDER_NODE,
      // main_fund_account: process.env.POCKET_NETWORK_MAIN_FUND_ACCOUNT,
      // main_fund_address: process.env.POCKET_NETWORK_MAIN_FUND_ADDRESS,

    };
  }
};
exports.ENV_VARS = ENV_VARS;

/**
 * Returns the corresponding object for the named passed
 *
 * @param {string} name name of the environment block
 *
 * @returns {object} object with scoped environment variables
 *
 */
function env(name) {
  // @ts-ignore
  return ENV_VARS[name]();
}
//# sourceMappingURL=environment.js.map