"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.errorHandler = void 0;

var _httpError = _interopRequireDefault(require("../errors/http-error"));

var errorHandler = function errorHandler() {
  return function (err, req, res, next) {
    var code;
    var body;

    if (err instanceof _httpError["default"]) {
      code = Number(err.code);
      body = err.content;
    }

    res.status(code || 500).send(body || {
      errors: [{
        id: 'REQUEST_ERR',
        message: 'There was an error with your request'
      }]
    });
  };
};

exports.errorHandler = errorHandler;
//# sourceMappingURL=utils.js.map