"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeDaysFromNowUtcDate = composeDaysFromNowUtcDate;
exports.composeHoursFromNowUtcDate = composeHoursFromNowUtcDate;
exports.composeTodayUtcDate = composeTodayUtcDate;

var _dayjs = _interopRequireDefault(require("dayjs"));

var _utc = _interopRequireDefault(require("dayjs/plugin/utc"));

function composeDaysFromNowUtcDate(daysAgo) {
  _dayjs["default"].extend(_utc["default"]);

  var dateDaysAgo = _dayjs["default"].utc().subtract(daysAgo, 'day');

  var formattedTimestamp = "".concat(dateDaysAgo.year(), "-0").concat(dateDaysAgo.month() + 1, "-").concat(dateDaysAgo.date(), "T00:00:00+00:00");
  return formattedTimestamp;
}

function composeHoursFromNowUtcDate(hoursAgo) {
  _dayjs["default"].extend(_utc["default"]);

  var dayAgo = _dayjs["default"].utc().subtract(hoursAgo, 'hour');

  var formattedTimestamp = "".concat(dayAgo.year(), "-0").concat(dayAgo.month() + 1, "-").concat(dayAgo.date(), "T").concat(dayAgo.hour() + 1, ":00:00+00:00");
  return formattedTimestamp;
}

function composeTodayUtcDate() {
  _dayjs["default"].extend(_utc["default"]);

  var today = _dayjs["default"].utc();

  var todayBucket = "".concat(today.year(), "-0").concat(today.month() + 1, "-").concat(today.date(), "T00:00:00+00:00");
  return todayBucket;
}
//# sourceMappingURL=date-utils.js.map