"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authenticate = void 0;

var _httpError = _interopRequireDefault(require("../errors/http-error"));

var _passportLocal = _interopRequireDefault(require("../lib/passport-local"));

var authenticate = function authenticate(req, res, next) {
  _passportLocal["default"].authenticate('jwt', {
    session: false
  }, function (err, user) {
    if (err) {
      return next(_httpError["default"].UNAUTHORIZED({
        errors: [{
          id: 'UNAUTHORIZED',
          message: 'Unauthorized'
        }]
      }));
    }

    if (!user) {
      return next(_httpError["default"].UNAUTHORIZED({
        errors: [{
          id: 'UNAUTHORIZED',
          message: 'Unauthorized'
        }]
      }));
    }

    req.user = user;
    return next();
  })(req, res, next);
};

exports.authenticate = authenticate;
//# sourceMappingURL=passport-auth.js.map