"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _mailgunJs = _interopRequireDefault(require("mailgun-js"));

var _environment = _interopRequireDefault(require("../environment"));

var FROM_EMAIL = 'Pocket Dashboard <dashboard@pokt.network>';
var DOMAIN = 'pokt.network';
var WHITELISTED_TEMPLATES = new Map([['NotificationChange', ['pocket-dashboard-notifications-changed', 'Pocket Dashboard: Notification settings']], ['NotificationSignup', ['pocket-dashboard-notifications-signup', "Pocket Dashboard: You've signed up for notifications"]], ['NotificationThresholdHit', ['pocket-dashboard-notifications-threshold-hit', 'Pocket Dashboard: App notification']], ['PasswordReset', ['pocket-dashboard-password-reset', 'Pocket Dashboard: Reset your password']], ['SignUp', ['pocket-dashboard-signup', 'Pocket Dashboard: Sign up']]]);

var MailgunService = /*#__PURE__*/function () {
  function MailgunService() {
    (0, _classCallCheck2["default"])(this, MailgunService);
    this.mailService = (0, _mailgunJs["default"])({
      apiKey: (0, _environment["default"])('EMAIL_API_KEY'),
      domain: DOMAIN
    });
  }

  (0, _createClass2["default"])(MailgunService, [{
    key: "send",
    value: function send(_ref) {
      var _ref$templateData = _ref.templateData,
          templateData = _ref$templateData === void 0 ? null : _ref$templateData,
          _ref$templateName = _ref.templateName,
          templateName = _ref$templateName === void 0 ? '' : _ref$templateName,
          _ref$toEmail = _ref.toEmail,
          toEmail = _ref$toEmail === void 0 ? '' : _ref$toEmail;

      var _WHITELISTED_TEMPLATE = WHITELISTED_TEMPLATES.get(templateName),
          _WHITELISTED_TEMPLATE2 = (0, _slicedToArray2["default"])(_WHITELISTED_TEMPLATE, 2),
          template = _WHITELISTED_TEMPLATE2[0],
          subject = _WHITELISTED_TEMPLATE2[1];

      var message = {
        from: FROM_EMAIL,
        to: toEmail,
        subject: subject,
        template: template
      };

      if (templateData) {
        message['h:X-Mailgun-Variables'] = JSON.stringify(templateData);
      }

      return this.mailService.messages().send(message);
    }
  }]);
  return MailgunService;
}();

exports["default"] = MailgunService;
//# sourceMappingURL=MailgunService.js.map