"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fillAppPool = fillAppPool;
exports.stakeAppPool = stakeAppPool;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _crypto = _interopRequireDefault(require("crypto"));

var _pocketJs = require("@pokt-network/pocket-js");

var _PreStakedApp = _interopRequireDefault(require("../models/PreStakedApp"));

var _config = require("./config");

var _pocket = require("../lib/pocket");

var _applicationStatuses = require("../application-statuses");

var _environment = _interopRequireDefault(require("../environment"));

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function createApplicationAndFund(_x) {
  return _createApplicationAndFund.apply(this, arguments);
}

function _createApplicationAndFund() {
  _createApplicationAndFund = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(ctx) {
    var _ref, clientPubKey, aatVersion, passphrase, freeTierAccount, gatewayAat, newAppForPool, txHash;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _ref = (0, _environment["default"])('POCKET_NETWORK'), clientPubKey = _ref.clientPubKey, aatVersion = _ref.aatVersion;
            passphrase = _crypto["default"].randomBytes(16).toString('hex');
            _context.next = 4;
            return (0, _pocket.createUnlockedAccount)(passphrase);

          case 4:
            freeTierAccount = _context.sent;
            _context.next = 7;
            return _pocketJs.PocketAAT.from(aatVersion, clientPubKey, freeTierAccount.publicKey.toString('hex'), freeTierAccount.privateKey.toString('hex'));

          case 7:
            gatewayAat = _context.sent;
            newAppForPool = new _PreStakedApp["default"]({
              status: _applicationStatuses.APPLICATION_STATUSES.AWAITING_FUNDS,
              freeTierApplicationAccount: {
                address: freeTierAccount.addressHex,
                publicKey: freeTierAccount.publicKey.toString('hex'),
                privateKey: freeTierAccount.privateKey.toString('hex'),
                passPhrase: passphrase
              },
              gatewayAAT: {
                version: gatewayAat.version,
                clientPublicKey: gatewayAat.clientPublicKey,
                applicationPublicKey: gatewayAat.applicationPublicKey,
                applicationSignature: gatewayAat.applicationSignature
              },
              createdAt: new Date(Date.now())
            });
            _context.next = 11;
            return newAppForPool.save();

          case 11:
            ctx.logger.log("fillAppPool(): created app with addr ".concat(freeTierAccount.addressHex));
            _context.next = 14;
            return (0, _pocket.transferFromFreeTierFund)(_config.FREE_TIER_STAKE_AMOUNT.toString(), freeTierAccount.addressHex);

          case 14:
            txHash = _context.sent;

            if (!txHash) {
              ctx.logger.warn("Funds were not sent for app ".concat(newAppForPool.freeTierApplicationAccount.address, "! This is an issue with connecting to the network with PocketJS."));
            }

            newAppForPool.status = _applicationStatuses.APPLICATION_STATUSES.AWAITING_STAKING;
            newAppForPool.fundingTxHash = txHash;
            _context.next = 20;
            return newAppForPool.save();

          case 20:
            ctx.logger.log("fillAppPool(): sent funds to account ".concat(freeTierAccount.addressHex, " on tx ").concat(txHash));

          case 21:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _createApplicationAndFund.apply(this, arguments);
}

function stakeApplication(_x2, _x3) {
  return _stakeApplication.apply(this, arguments);
}

function _stakeApplication() {
  _stakeApplication = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(ctx, app) {
    var chain,
        _app$freeTierApplicat,
        address,
        passPhrase,
        privateKey,
        _ref2,
        balance,
        stakeTxToSend,
        txHash,
        _args2 = arguments;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            chain = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : '0002';
            _app$freeTierApplicat = app.freeTierApplicationAccount, address = _app$freeTierApplicat.address, passPhrase = _app$freeTierApplicat.passPhrase, privateKey = _app$freeTierApplicat.privateKey;
            _context2.next = 4;
            return (0, _pocket.getBalance)(address);

          case 4:
            _ref2 = _context2.sent;
            balance = _ref2.balance;

            if (!(balance < _config.FREE_TIER_STAKE_AMOUNT)) {
              _context2.next = 9;
              break;
            }

            ctx.logger.warn("NOTICE! app ".concat(app.freeTierApplicationAccount.address, " doesn't have enough funds."));
            return _context2.abrupt("return");

          case 9:
            ctx.logger.log("Staking app ".concat(address, " for chain ").concat(chain));
            _context2.next = 12;
            return (0, _pocket.createAppStakeTx)(passPhrase, Buffer.from(privateKey, 'hex'), [chain], _config.FREE_TIER_STAKE_AMOUNT.toString());

          case 12:
            stakeTxToSend = _context2.sent;
            _context2.next = 15;
            return (0, _pocket.submitRawTransaction)(address, stakeTxToSend.txHex);

          case 15:
            txHash = _context2.sent;
            app.status = _applicationStatuses.APPLICATION_STATUSES.READY;
            app.stakingTxHash = txHash;
            app.chain = chain;
            ctx.logger.log("App ".concat(app.freeTierApplicationAccount.address, " is now ready: tx hash ").concat(txHash));
            _context2.next = 22;
            return app.save();

          case 22:
            ctx.logger.log("Sent stake request on tx ".concat(txHash, " : app ").concat(address, ", chain ").concat(chain));

          case 23:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _stakeApplication.apply(this, arguments);
}

function fillAppPool(_x4) {
  return _fillAppPool.apply(this, arguments);
}

function _fillAppPool() {
  _fillAppPool = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(ctx) {
    var _appPool$length;

    var totalPoolSize, appPool, appsToCreate;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            // const totalPoolSize = Object.values(chains).reduce(
            //   (prev, { limit }) => prev + limit,
            //   0
            // );
            totalPoolSize = 42;
            _context4.next = 3;
            return _PreStakedApp["default"].find();

          case 3:
            appPool = _context4.sent;
            ctx.logger.log("fillAppPool(): pool size limit ".concat(totalPoolSize, ", pool size ").concat(appPool === null || appPool === void 0 ? void 0 : appPool.length));

            if (!(totalPoolSize <= appPool.length)) {
              _context4.next = 8;
              break;
            }

            ctx.logger.log('fillAppPool(): No need to fill the pool.');
            return _context4.abrupt("return");

          case 8:
            appsToCreate = totalPoolSize - ((_appPool$length = appPool === null || appPool === void 0 ? void 0 : appPool.length) !== null && _appPool$length !== void 0 ? _appPool$length : 0);
            ctx.logger.log("fillAppPool(): creating ".concat(appsToCreate, " apps"));
            Array(appsToCreate).fill(0).map( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
              return _regenerator["default"].wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      _context3.next = 2;
                      return createApplicationAndFund(ctx);

                    case 2:
                    case "end":
                      return _context3.stop();
                  }
                }
              }, _callee3);
            })));

          case 11:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _fillAppPool.apply(this, arguments);
}

function stakeAppPool(_x5) {
  return _stakeAppPool.apply(this, arguments);
}

function _stakeAppPool() {
  _stakeAppPool = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(ctx) {
    var appPool, appsToStake, stakedApps, appAllocationCount, _i, _Object$entries, _Object$entries$_i, _Object$entries$_i$, id, limit, _iterator, _step, chain, currentCount, _iterator2, _step2, _loop, _ret;

    return _regenerator["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return _PreStakedApp["default"].find();

          case 2:
            appPool = _context6.sent;
            appsToStake = appPool.filter(function (_ref4) {
              var status = _ref4.status;
              return status === _applicationStatuses.APPLICATION_STATUSES.AWAITING_STAKING;
            });
            stakedApps = appPool.filter(function (_ref5) {
              var status = _ref5.status;
              return status === _applicationStatuses.APPLICATION_STATUSES.READY;
            });
            appAllocationCount = new Map();

            if (appsToStake.length) {
              _context6.next = 9;
              break;
            }

            ctx.logger.log('No apps to stake');
            return _context6.abrupt("return");

          case 9:
            // fill the allocation count with the default from all chains
            for (_i = 0, _Object$entries = Object.entries(_config.chains); _i < _Object$entries.length; _i++) {
              _Object$entries$_i = (0, _slicedToArray2["default"])(_Object$entries[_i], 2), _Object$entries$_i$ = _Object$entries$_i[1], id = _Object$entries$_i$.id, limit = _Object$entries$_i$.limit;
              appAllocationCount.set(id, limit);
            } // Now, remove the excess entries depending on the pool allocation


            _iterator = _createForOfIteratorHelper(stakedApps);
            _context6.prev = 11;

            _iterator.s();

          case 13:
            if ((_step = _iterator.n()).done) {
              _context6.next = 22;
              break;
            }

            chain = _step.value.chain;

            if (!(chain && !appAllocationCount.has(chain))) {
              _context6.next = 18;
              break;
            }

            ctx.logger.warn("stakeAppPool(): Found chain ".concat(chain, " not found in chains config"));
            return _context6.abrupt("continue", 20);

          case 18:
            currentCount = appAllocationCount.get(chain);
            appAllocationCount.set(chain, Math.max(currentCount - 1, 0));

          case 20:
            _context6.next = 13;
            break;

          case 22:
            _context6.next = 27;
            break;

          case 24:
            _context6.prev = 24;
            _context6.t0 = _context6["catch"](11);

            _iterator.e(_context6.t0);

          case 27:
            _context6.prev = 27;

            _iterator.f();

            return _context6.finish(27);

          case 30:
            _iterator2 = _createForOfIteratorHelper(appAllocationCount);
            _context6.prev = 31;

            _loop = function _loop() {
              var _step2$value = (0, _slicedToArray2["default"])(_step2.value, 2),
                  chain = _step2$value[0],
                  count = _step2$value[1];

              if (!count) {
                return "continue";
              }

              ctx.logger.log("Creating ".concat(count, " apps for chain ").concat(chain));
              Array(count).fill(0).map( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
                var chosenApplication;
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        chosenApplication = appsToStake.pop();

                        if (chosenApplication) {
                          _context5.next = 4;
                          break;
                        }

                        ctx.logger.warn("NOTICE: No more space in the pool for app demand. Tried to stake for ".concat(chain, " but no more stake-ready apps were left in the pool."));
                        return _context5.abrupt("return");

                      case 4:
                        ctx.logger.log("Staking application ".concat(chosenApplication.freeTierApplicationAccount.address, " for chain ").concat(chain));
                        _context5.next = 7;
                        return stakeApplication(ctx, chosenApplication, chain);

                      case 7:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              })));
            };

            _iterator2.s();

          case 34:
            if ((_step2 = _iterator2.n()).done) {
              _context6.next = 40;
              break;
            }

            _ret = _loop();

            if (!(_ret === "continue")) {
              _context6.next = 38;
              break;
            }

            return _context6.abrupt("continue", 38);

          case 38:
            _context6.next = 34;
            break;

          case 40:
            _context6.next = 45;
            break;

          case 42:
            _context6.prev = 42;
            _context6.t1 = _context6["catch"](31);

            _iterator2.e(_context6.t1);

          case 45:
            _context6.prev = 45;

            _iterator2.f();

            return _context6.finish(45);

          case 48:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, null, [[11, 24, 27, 30], [31, 42, 45, 48]]);
  }));
  return _stakeAppPool.apply(this, arguments);
}
//# sourceMappingURL=application.js.map