"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startWorkers = startWorkers;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _nodeCron = _interopRequireDefault(require("node-cron"));

var _logger = _interopRequireDefault(require("@pokt-foundation/pocket-dashboard-shared/helpers/logger"));

var _config = require("./config");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var ONE_SECOND = 1000;

function startWorkers() {
  _logger["default"].setDefaults({
    silent: false,
    verbose: true
  });

  var logger = (0, _logger["default"])('dashboard-workers');

  var _iterator = _createForOfIteratorHelper(_config.workers),
      _step;

  try {
    var _loop = function _loop() {
      var _step$value = _step.value,
          name = _step$value.name,
          color = _step$value.color,
          workerFn = _step$value.workerFn,
          recurrence = _step$value.recurrence;

      _nodeCron["default"].schedule(recurrence, /*#__PURE__*/function () {
        var _handleWorkerProcess = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
          var startTime, endTime, startInUtc, endInUtc, elapsedTime;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  startTime = Date.now();
                  startInUtc = new Date(startTime).toUTCString();
                  logger.log("Starting worker \"".concat(name, "\" at ").concat(startInUtc, " with color ").concat(color));
                  _context.prev = 3;
                  _context.next = 6;
                  return workerFn({
                    logger: logger
                  });

                case 6:
                  endTime = Date.now();
                  endInUtc = new Date(endTime).toUTCString();
                  elapsedTime = (endTime - startTime) / ONE_SECOND;
                  logger.success("Worker ".concat(name, " exited successfully at ").concat(endInUtc, ", took ").concat(elapsedTime, " seconds"));
                  _context.next = 16;
                  break;

                case 12:
                  _context.prev = 12;
                  _context.t0 = _context["catch"](3);
                  logger.error("Worker ".concat(name, " exited with an error.")); // TODO: Send metrics to sentry

                  logger.log(_context.t0.message);

                case 16:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[3, 12]]);
        }));

        function handleWorkerProcess() {
          return _handleWorkerProcess.apply(this, arguments);
        }

        return handleWorkerProcess;
      }());
    };

    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      _loop();
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}
//# sourceMappingURL=index.js.map