"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNetworkStatsCount = getNetworkStatsCount;
exports.getNodeCountForChains = getNodeCountForChains;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _pocketJs = require("@pokt-network/pocket-js");

var _NetworkData = _interopRequireDefault(require("../models/NetworkData"));

var _Blockchains = _interopRequireDefault(require("../models/Blockchains"));

var _pocket = require("../lib/pocket");

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function getTotalNodesStaked() {
  return _getTotalNodesStaked.apply(this, arguments);
}

function _getTotalNodesStaked() {
  _getTotalNodesStaked = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var stakedNodes;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _pocket.getNodes)(_pocketJs.StakingStatus.Staked);

          case 2:
            stakedNodes = _context.sent;

            if (!(!stakedNodes || (stakedNodes === null || stakedNodes === void 0 ? void 0 : stakedNodes.length) === 0)) {
              _context.next = 5;
              break;
            }

            throw new Error('PocketJS failed to retrieve staked nodes');

          case 5:
            return _context.abrupt("return", stakedNodes.length);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _getTotalNodesStaked.apply(this, arguments);
}

function getTotalAppsStaked() {
  return _getTotalAppsStaked.apply(this, arguments);
}

function _getTotalAppsStaked() {
  _getTotalAppsStaked = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
    var stakedApps;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _pocket.getApplications)(_pocketJs.StakingStatus.Staked);

          case 2:
            stakedApps = _context2.sent;

            if (!(!stakedApps || (stakedApps === null || stakedApps === void 0 ? void 0 : stakedApps.length) === 0)) {
              _context2.next = 5;
              break;
            }

            throw new Error('PocketJS failed to retrieve staked apps');

          case 5:
            return _context2.abrupt("return", stakedApps.length);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _getTotalAppsStaked.apply(this, arguments);
}

function getTotalPoktStaked() {
  return _getTotalPoktStaked.apply(this, arguments);
}

function _getTotalPoktStaked() {
  _getTotalPoktStaked = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    var stakedNodes, stakedApps, totalNodePoktStaked, totalAppPoktStaked;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _pocket.getNodes)(_pocketJs.StakingStatus.Staked);

          case 2:
            stakedNodes = _context3.sent;
            _context3.next = 5;
            return (0, _pocket.getApplications)(_pocketJs.StakingStatus.Staked);

          case 5:
            stakedApps = _context3.sent;
            totalNodePoktStaked = stakedNodes.reduce(function (prev, cur) {
              return prev + BigInt(cur.stakedTokens);
            }, 0n);
            totalAppPoktStaked = stakedApps.reduce(function (prev, cur) {
              return prev + BigInt(cur.stakedTokens);
            }, 0n);
            return _context3.abrupt("return", BigInt(totalNodePoktStaked + totalAppPoktStaked));

          case 9:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getTotalPoktStaked.apply(this, arguments);
}

function getNetworkStatsCount(_x) {
  return _getNetworkStatsCount.apply(this, arguments);
}

function _getNetworkStatsCount() {
  _getNetworkStatsCount = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(ctx) {
    var totalNodesStaked, totalAppsStaked, totalPoktStaked, networkStats;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return getTotalNodesStaked();

          case 2:
            totalNodesStaked = _context4.sent;
            _context4.next = 5;
            return getTotalAppsStaked();

          case 5:
            totalAppsStaked = _context4.sent;
            _context4.next = 8;
            return getTotalPoktStaked();

          case 8:
            totalPoktStaked = _context4.sent;
            networkStats = new _NetworkData["default"]({
              nodesStaked: totalNodesStaked,
              appsStaked: totalAppsStaked,
              poktStaked: totalPoktStaked.toString(),
              createdAt: new Date(Date.now())
            });
            _context4.next = 12;
            return networkStats.save();

          case 12:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getNetworkStatsCount.apply(this, arguments);
}

function getNodeCountForChains(_x2) {
  return _getNodeCountForChains.apply(this, arguments);
}

function _getNodeCountForChains() {
  _getNodeCountForChains = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(ctx) {
    var chainNodeCounter, stakedNodes, _iterator, _step, chains, _iterator2, _step2, chainId, currentCount;

    return _regenerator["default"].wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            chainNodeCounter = new Map();
            _context6.next = 3;
            return (0, _pocket.getNodes)(_pocketJs.StakingStatus.Staked);

          case 3:
            stakedNodes = _context6.sent;

            if (stakedNodes) {
              _context6.next = 6;
              break;
            }

            throw new Error('pocketJS failed when fetching nodes');

          case 6:
            _iterator = _createForOfIteratorHelper(stakedNodes);

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                chains = _step.value.chains;
                _iterator2 = _createForOfIteratorHelper(chains);

                try {
                  for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                    chainId = _step2.value;

                    if (!chainNodeCounter.has(chainId)) {
                      chainNodeCounter.set(chainId, 0);
                    } else {
                      currentCount = Number(chainNodeCounter.get(chainId));
                      chainNodeCounter.set(chainId, currentCount + 1);
                    }
                  }
                } catch (err) {
                  _iterator2.e(err);
                } finally {
                  _iterator2.f();
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            chainNodeCounter.forEach( /*#__PURE__*/function () {
              var _updateChainCount = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(count, id) {
                var blockchain;
                return _regenerator["default"].wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.next = 2;
                        return _Blockchains["default"].findById(id);

                      case 2:
                        blockchain = _context5.sent;

                        if (blockchain) {
                          _context5.next = 6;
                          break;
                        }

                        ctx.logger.warn("NOTICE: chain ".concat(id, " not detected, count of nodes is ").concat(count));
                        return _context5.abrupt("return");

                      case 6:
                        blockchain.nodeCount = count;
                        _context5.next = 9;
                        return blockchain.save();

                      case 9:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              function updateChainCount(_x3, _x4) {
                return _updateChainCount.apply(this, arguments);
              }

              return updateChainCount;
            }());

          case 9:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _getNodeCountForChains.apply(this, arguments);
}
//# sourceMappingURL=network.js.map